user/models.py
#!/usr/bin/env python3
# -*- coding: UTF-8 -*-
from app import BaseModel
import peewee as pw
from werkzeug.security import check_password_hash
from hashlib import md5
from flask_login import UserMixin

from enum import Enum, unique
from user import user_blue
import os
import shutil
import requests
from io import BytesIO
from PIL import Image


#添加 unique 装饰器
@unique
class User_state(Enum):
    #用户状态：0为普通用户，-1为封号，1为管理员
    Normal = 0
    Admin = 1
    Under_ban = -1
    '''
    -1 封号
    0 游客
    1 普通用户
    20 管理员
    999 系统管理员
    '''


@unique
class User_Campus_state(Enum):
    SiPing = "四平路校区"
    JiaDing = "嘉定校区"
    HuXi = "沪西校区"
    HuBei = "沪北校区"


class User(UserMixin, BaseModel):
    """
    用户类
    继承自UserMixin，可以方便地使用各种flask_login的API
    同时继承自BaseModel，直接关联db，并且也继承了Model Model有提供增删查改的函数
    用户头像统一存储在./user/static/resource/user-pic/{user-id}/avatar.WEBP
    要换头像就先把avatar.WEBP放到同目录下history文件夹中，名字随机命名，然后再把用户上传的头像压缩成jpg放在指定目录
    """
    #id = pw.IntegerField(primary_key=True)  # 主键，不显式定义的话peewee默认定义一个自增的id
    username = pw.CharField(verbose_name='用户名,这里保证唯一',
                            max_length=64,
                            index=True,
                            null=False,
                            unique=True)
    email = pw.CharField(verbose_name="唯一的邮箱",
                         max_length=128,
                         index=True,
                         null=False,
                         unique=True)

    #用户状态：0为普通用户，-1为封号，1为管理员
    state = pw.IntegerField(verbose_name="状态",
                            null=False,
                            default=User_state.Normal.value,
                            constraints=[pw.Check("state >=-1")])
    score = pw.IntegerField(verbose_name="信誉分", default=100)  #信誉分小于零可封号

    #以下为个人信息栏
    gender = pw.CharField(verbose_name="性别",
                          max_length=4,
                          default='保密',
                          constraints=[pw.Check("gender in ('男', '女','保密')")
                                       ])  #三个图标

    user_no_is_published = pw.BooleanField(verbose_name="是否公开学工号",
                                           default=False)
    user_no = pw.CharField(verbose_name="学工号,字符串存储便于拓展",
                           index=True,
                           max_length=64)
    #应甲方要求，为方便留学生使用
    #中国用户用+86 1xx xxxx xxxx存 其他国家用其他的前缀
    telephone_is_published = pw.BooleanField(verbose_name="是否公开电话号码",
                                             default=False)
    telephone = pw.CharField(verbose_name="电话号码", max_length=64)
    wechat_is_published = pw.BooleanField(verbose_name="是否公开微信号",
                                          default=False)
    wechat = pw.CharField(verbose_name="微信号", max_length=128)
    qq_is_published = pw.BooleanField(verbose_name="是否公开QQ号", default=False)
    qq_number = pw.CharField(verbose_name="QQ号,字符串存储便于拓展", max_length=64)

    campus_is_published = pw.BooleanField(verbose_name="是否公开所在校区",
                                          default=False)
    campus_branch = pw.CharField(
        verbose_name="所在校区",
        max_length=32,
        null=False,
        default=User_Campus_state.SiPing.value,
        constraints=[
            pw.Check("campus_branch in ('四平路校区','嘉定校区','沪西校区','沪北校区')")
        ])
    dormitory_is_published = pw.BooleanField(verbose_name="是否公开宿舍楼",
                                             default=False)
    dormitory = pw.CharField(verbose_name="所在宿舍楼", max_length=32)

    name_is_published = pw.BooleanField(verbose_name="是否公开姓名", default=False)
    name = pw.CharField(verbose_name="真实姓名", max_length=64)
    major_is_published = pw.BooleanField(verbose_name="是否公开专业", default=False)
    major = pw.CharField(verbose_name="专业", max_length=32)

    password_hash = pw.CharField(max_length=128)  #保证安全，只存密码的哈希，不存密码

    def check_password(self, password):
        return check_password_hash(self.password_hash, password)

    def __repr__(self):
        return '<用户名:{}>'.format(self.username)

    #avatar_path 头像地址可以默认定为./resource/pic/avatar/student_number.jpg
    def create_avatar(self):  # 一个根据邮箱自动获取分形图的API，可用来作为用户头像
        digest = md5(self.email.lower().encode('utf-8')).hexdigest()
        sizes = [256, 128, 64]
        url = f'https://gravatar.zeruns.tech/avatar/{digest}?d=identicon&s={sizes[0]}'
        curpath = os.path.join(os.path.dirname(__file__),
                               'static/resource/user-pic/')
        if not os.path.exists(os.path.join(curpath, f'{self.id}/')):
            os.makedirs(os.path.join(curpath, f'{self.id}/'))

        try:
            img = Image.open(BytesIO(requests.get(url).content))
        except:
            img = Image.open(os.path.join(curpath, f'default_avatar.jpg'))

        img.save(os.path.join(curpath, f'{self.id}/avatar.WEBP'), "WEBP")
        img.convert('RGBA')

        for size in sizes:
            img2 = img.resize((size, size))
            img2.save(os.path.join(curpath, f'{self.id}/avatar_{size}.WEBP'),
                      "WEBP")

    @classmethod
    def clear_pic(cls):
        pic_base_path = os.path.join(user_blue.static_folder,
                                     f"resource/user-pic")
        now_list = cls.get_list([cls.id]).tuples()
        now_list = list(map(lambda x: str(x[0]), now_list))
        for i in os.listdir(pic_base_path):
            tep_path = os.path.join(pic_base_path, i)
            if os.path.isdir(tep_path):
                if i not in now_list:
                    shutil.rmtree(tep_path)

user/__init__.py
#!/usr/bin/env python3
# -*- coding: UTF-8 -*-

###用户、收藏、历史

from flask import Blueprint

user_blue = Blueprint('user', __name__,template_folder="templates",static_folder="static")

from . import models
from . import routes

user/routes.py
#!/usr/bin/env python3
# -*- coding: UTF-8 -*-
from user import user_blue
from flask import render_template, flash, redirect, url_for, request
from user.models import User
from flask_login import current_user, login_user, logout_user, login_required
from app import database


@user_blue.before_request
def before_request():
    if database.is_closed():
        database.connect()


@user_blue.teardown_request
def teardown_request(exc):  #exc必须写上
    if not database.is_closed():
        database.close()


@user_blue.route("/", methods=['GET', 'POST'])
def root_index():
    return redirect(url_for('user.index'))  # 重定向到/user/index


@user_blue.route('/index', methods=['GET', 'POST'])
def index():
    if current_user.is_authenticated:
        return render_template("user_index.html",
                               current_user=current_user)  #html的名字不能相同
    else:
        return redirect(url_for('index'))


@user_blue.route('/publish', methods=['GET', 'POST'])
def publish():
    if current_user.is_authenticated:
        return render_template("user_publish.html", current_user=current_user)
    else:
        return redirect(url_for('login'))


#个人中心
@user_blue.route('/space', methods=['GET', 'POST'])
def space():
    return redirect(url_for('user.order'))
    if current_user.is_authenticated:
        return render_template('user_space.html', current_user=current_user)
    else:
        return redirect(url_for('login'))


#个人信息管理
@user_blue.route('/<opt_userid>/user_info', methods=['GET', 'POST'])
def user_info(opt_userid: int):  #opt_userid为目标用户ID
    if current_user.is_authenticated:
        try:
            user = User.get_by_id(opt_userid)
        except:
            return render_template('404.html', message="找不到该用户")
        return render_template('user_info.html',
                               current_user=current_user,
                               opt_userid=int(opt_userid))
    else:
        return render_template('404.html', error_code=401, message="请先登录")


@user_blue.route('/order', methods=['GET', 'POST'])
def order():
    return render_template("user_order.html", current_user=current_user)


#个人认为，“我的订单”页面不应该被别人看见


#历史
@user_blue.route('/history', methods=['GET', 'POST'])
def history():
    if current_user.is_authenticated:
        return render_template('user_history.html')
    else:
        return redirect(url_for('login'))


#收藏
@user_blue.route('/favor', methods=['GET', 'POST'])
def favor():
    if current_user.is_authenticated:
        return render_template('user_favor.html')
    else:
        return redirect(url_for('login'))


@user_blue.route('/address', methods=['GET', 'POST'])
def address():
    if current_user.is_authenticated:
        return render_template('user_address.html')
    else:
        return redirect(url_for('login'))


@user_blue.route("/feedback", methods=["GET", "POST"])
def feedback():
    if current_user.is_authenticated:
        return render_template('user_feedback.html')
    else:
        return redirect(url_for('login'))

user/templates/cont_side.html
<aside class="shop-sidebar" style="padding-left: 45px">
    <div class="widget shop-widget">
        <div class="shop-widget-title">
            <h6 class="title">订单管理</h6>
        </div>
        <div class="shop-cat-list">
            <ul>
                <li><a href="{{ url_for('user.order') }}">我的订单</a></li>
                <li><a href="{{ url_for('user.publish') }}">我的发布</a></li>
                <li><a href="{{ url_for('user.favor') }}">我的收藏</a></li>
                <li><a href="{{ url_for('user.history') }}">我的足迹</a></li>
            </ul>
        </div>
        <br />
        <div class="shop-widget-title">
            <h6 class="title">我的账户</h6>
        </div>
        <div class="shop-cat-list">
            <ul>
                <li><a href="{{ url_for('user.user_info',opt_userid=current_user.id) }}">个人资料</a></li>
                <li><a href="{{ url_for('user.address') }}">地址管理</a></li>
            </ul>
        </div>
        <br />
        {% if current_user.state==1 %}
        <div class="shop-widget-title">
            <h6 class="title">用户管理</h6>
        </div>
        <div class="shop-cat-list">
            <ul>
                <li><a href="{{url_for('admin.feedback_show')}}">反馈管理</a></li>
                <li><a href="{{url_for('admin.order_check')}}">订单管理</a></li>
                <li><a href="{{url_for('admin.user_check')}}">用户管理</a></li>
            </ul>
        </div>
        {% endif %}
    </div>
</aside>

user/templates/user_address.html
{% extends "base.html" %} {% block title %}
<title>编辑地址</title>
<link rel="stylesheet" type="text/css" href="{{url_for('user.static',filename='css/Switch.css')}}" />

{% endblock %} {% block css %} {{ super() }} {% endblock %} {% block header %} {{ super() }} {% endblock %} {% block main %}
<main>
    <section class="shop--area shop-right-sidebar pt-90 pb-90">
        <div class="container">
            <div class="row justify-content-center">
                <div class="col-xl-3 col-lg-3 col-md-3 col-sm-12">{% include "cont_side.html" %}</div>
                <div class="col-xl-9 col-lg-9 col-md-9 col-sm-12">
                    <b>请双击表单内容进行修改</b>
                    <div class="cart-wrapper">
                        <div class="table-responsive">
                            <table id="tab" border="0" cellspacing="0" cellpadding="0" class="table">
                                <thead class="thead-light">
                                    <tr>
                                        <th>收件人</th>
                                        <th>电话</th>
                                        <th>详细地址</th>
                                        <th>所在校区</th>
                                        <th>设为默认</th>
                                        <th></th>
                                    </tr>
                                </thead>
                                <tbody id="ta"></tbody>
                            </table>
                        </div>
                    </div>
                    <div class="shop-cart-total" style="margin-top: 0px; background-color: rgba(255, 255, 255, 0); border: none">
                        <div class="shop-cart-widget">
                            <a class="btn" data-toggle="modal" data-target="#address">添加新地址</a>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <div class="container">
            <div class="row justify-content-center">
                <div class="col-lg-7">
                    <div class="modal fade" id="address" tabindex="-1" role="dialog" aria-hidden="true">
                        <div class="modal-dialog" role="document">
                            <div class="modal-content">
                                <div class="modal-header">
                                    <h5 class="modal-title" id="exampleModalLabel">添加新地址</h5>
                                </div>
                                <div class="modal-body">
                                    <form action="javascript:void(0);">
                                        <div class="form-group">
                                            <label class="col-form-label">收件人姓名:</label>
                                            <input type="text" class="form-control" id="rname" />
                                        </div>
                                        <div class="form-group">
                                            <label class="col-form-label">电话:</label>
                                            <input type="text" class="form-control" id="rtel" />
                                        </div>
                                        <div class="form-group">
                                            <label class="col-form-label">详细地址:</label>
                                            <input type="text" class="form-control" id="raddress" />
                                        </div>
                                        <div class="form-group">
                                            <label class="col-form-label">所在校区:</label>
                                            <select class="custom-select" id="rcampus">
                                                <option>四平路校区</option>
                                                <option>嘉定校区</option>
                                                <option>沪西校区</option>
                                                <option>沪北校区</option>
                                            </select>
                                        </div>
                                    </form>
                                </div>
                                <div class="modal-footer">
                                    <button type="button" class="btn btn-secondary" data-dismiss="modal">关闭</button>
                                    <button type="button" class="btn" onclick="add_address()">提交</button>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </section>
</main>
{% endblock %} {% block footer %} {{ super() }} {% endblock %} {% block js %} {{ super() }}

<script type="text/javascript" charset="utf-8">
    var debug = 0;

    function draw_table() {
        let url = "/api/get_address";
        if (debug) url = `http://127.0.0.1:4523/mock/927026${url}`;
        $.ajax({
            url: url,
            type: "get",
            success: function (ret) {
                let ta_tab = $("#ta");
                ta_tab.empty();
                for (let i = 0; i < ret.data.length; i++) {
                    ta_tab.append(`<tr id="tr${i}"></tr>`); //添加一列
                    let tab = $(`#tr${i}`); //把这一列的内容添加上
                    let contact_id = ret.data[i].id;
                    let campus_branch_select_text = get_branch_select_text(contact_id, ret.data[i].campus_branch);
                    let default_button_text = get_default_button_text(contact_id, ret.data[i].default);
                    //console.log(campus_branch_select_text);
                    tab.append(`<td class='edit_text' id='name${contact_id}'>${ret.data[i].name}</td>`);
                    tab.append(`<td class='edit_text' id='telephone${contact_id}'>${ret.data[i].telephone}</td>`);
                    tab.append(`<td class='edit_text' id='full_address${contact_id}'>${ret.data[i].full_address}</td>`);
                    tab.append(`<td id='campus_branch${contact_id}'>${campus_branch_select_text}</td>`);
                    tab.append(`<td>${default_button_text}</td>`);
                    tab.append(`<td><input type='button' class='btn btn-success' id='delete_contact_id${contact_id}' onclick='delete_by_id(${contact_id})' value='删除'</td>`);
                }

                /* 给表格里面每一个带有edit_text的td添加一个dblclick事件 */
                $(".edit_text").dblclick(function () {
                    /* 1.先拿到这个td原来的值，然后将这个td变成一个input:text,并且原来的值不动 */
                    var tdVal = $(this).text();
                    let id = parseInt($(this).attr("id").replace(/[^\d]/g, " "));
                    let oInput = $("<input type='text' value='" + tdVal + "'/>");
                    $(this).html(oInput);
                    oInput.focus();

                    /* 2.失去焦点，这个td变为原来的text，value为修改过后的value */
                    oInput.blur(function () {
                        if (oInput.val() == "") {
                            suspend("alert-danger", "不可为空");
                            oInput.parent().html(tdVal);
                        } else {
                            oInput.parent().html(oInput.val());
                            if (oInput.val() != tdVal) update_contact(id);
                        }
                    });
                });
            },
        });
    }

    $(document).ready(function () {
        draw_table();
    });

    function checkboxOnblur(checkbox) {
        let id = parseInt(checkbox.id.replace(/[^\d]/g, " "));
        update_contact(id);
    }
    function selectOnblur(select) {
        let id = parseInt(select.id.replace(/[^\d]/g, " "));
        update_contact(id);
    }

    function checkboxOnclick(checkbox) {
        if (checkbox.checked == true) {
            $(".switch").each(function (index, obj) {
                obj.checked = false;
            });
            $("#" + checkbox.id)[0].checked = true;
            checkboxOnblur(checkbox);
        } else {
            let f_has_true = false;
            $(".switch").each(function (index, obj) {
                if (obj.checked) f_has_true = true;
            });
            if (f_has_true) {
                $("#" + checkbox.id)[0].checked = false;
                checkboxOnblur(checkbox);
            } else {
                checkbox.checked = true;
                //alert("必须要有一个默认地址！");
            }
        }
    }
    function get_branch_select_text(id, campus_branch) {
        let res = `<select  class="custom-select" id=select_campus_branch${id} onchange="selectOnblur(this)">`;
        let branchs = ["四平路校区", "嘉定校区", "沪西校区", "沪北校区"];
        for (let i = 0; i < branchs.length; i++) {
            if (campus_branch == branchs[i]) res += `<option value='select${i}' selected>${branchs[i]}</option>`;
            else res += `<option value='select${i}'>${branchs[i]}</option>`;
        }
        res += "</select>";
        return res;
    }
    function get_default_button_text(contact_id, is_default) {
        let res;
        if (is_default) res = `<input type="checkbox" class="switch" checked="checked" id='is_default${contact_id}' onclick="checkboxOnclick(this)" />`;
        else
            res = `<input class="switch" type="checkbox" id='is_default${contact_id}'
        onclick="checkboxOnclick(this)" />`;
        return res;
    }
    function delete_by_id(id) {
        let url = "/api/address";
        if (debug) url = `http://127.0.0.1:4523/mock/927026${url}`;
        $.ajax({
            url: url,
            type: "delete",
            data: JSON.stringify([{ contact_id: id }]),
            contentType: "application/json;charset=utf-8",
            processData: false,
            //async: false, // 当需要将值传给函数外部时需要强制同步
            success: function (ret) {
                if (ret.statusCode == 200) {
                    suspend("alert-success", "删除成功");
                    //$(`#delete_contact_id${id}`).parent().parent().remove();
                    draw_table();
                } else bootbox.alert(ret.message);
            },
        });
    }

    function update_contact(id) {
        let url = "/api/address";
        if (debug) url = `http://127.0.0.1:4523/mock/927026${url}`;
        let name = $(`#name${id}`).text();
        if (name == "") {
            alert("收件人不可为空");
            window.location.reload();
        }
        let telephone = $(`#telephone${id}`).text();
        if (telephone == "") {
            alert("电话不可为空");
            window.location.reload();
        }
        let campus_branch = $(`#select_campus_branch${id} option:selected`).text();
        let is_default = $(`#is_default${id}`).get(0).checked;
        let full_address = $(`#full_address${id}`).text();
        if (full_address == "") {
            alert("详细地址不可为空");
            window.location.reload();
        }
        $.ajax({
            url: url,
            type: "put",
            data: JSON.stringify([{ id: id, name: name, telephone: telephone, campus_branch: campus_branch, default: is_default, full_address: full_address }]),
            contentType: "application/json;charset=utf-8",
            processData: false,
            //async: false, // 当需要将值传给函数外部时需要强制同步
            success: function (ret) {
                if (ret.statusCode == 200) {
                    suspend("alert-success", "修改保存成功");
                } else {
                    suspend("alert-danger", "修改保存失败：" + ret.message);
                    sleep(500).then(() => {
                        window.location.reload();
                    });
                }
            },
        });
    }

    function add_address() {
        let url = "/api/address";
        if (debug) url = `http://127.0.0.1:4523/mock/927026${url}`;

        let name = $("#rname").val();
        if (name == "") {
            suspend("alert-danger", "收件人姓名不可为空");
            return;
        }
        let tel = $("#rtel").val();
        if (tel == "") {
            suspend("alert-danger", "电话不可为空");
            return;
        }
        let address = $("#raddress").val();
        if (address == "") {
            suspend("alert-danger", "详细地址不可为空");
            return;
        }
        let campus = $("#rcampus").val();

        $(".modal-input").val(""); //清空所有input的数据
        $.ajax({
            url: url,
            type: "post",
            data: JSON.stringify([{ name: name, telephone: tel, campus_branch: campus, default: false, full_address: address }]),
            contentType: "application/json;charset=utf-8",
            processData: false,
            //async: false, // 当需要将值传给函数外部时需要强制同步
            success: function (ret) {
                if (ret.statusCode == 200) {
                    suspend("alert-success", "添加成功");
                    draw_table();
                    $("#address").modal("hide");
                } else bootbox.alert(ret.message);
            },
        });
    }
</script>
{% endblock %}

user/templates/user_space.html
{% extends "base.html" %} {% block title %}
<title>我的空间</title>
{% endblock %} {% block css %} {{ super() }} {% endblock %} {% block header %} {{ super() }} {% endblock %} {% block main %}
<main>
    <section class="shop--area shop-right-sidebar pt-90 pb-90">
        <div class="container">
            <div class="row justify-content-center">
                <div class="col-xl-3 col-lg-3 col-md-3 col-sm-12">{% include "cont_side.html" %}</div>
                <div class="col-xl-9 col-lg-9 col-md-9 col-sm-12">
                    <div class="member_main">
                        <div class="m-userinfo" style="border-radius: 15px">
                            <div class="s-userbar s-bar" style="border-radius: 5px; padding-top: 20px">
                                <div class="s-baseinfo" style="border-radius: 5px">
                                    <!-- <a href="404.html" class="s-avatar">
                                        <span class="s-edit-mask">修改头像</span>
                                        <img src="{{url_for('static', filename='img/images/user1.png')}}" />
                                    </a> -->
                                    <div class="s-name">
                                        <a href="#">
                                            <em>{{current_user.username}}</em>
                                            ({{current_user.id}})
                                        </a>
                                    </div>
                                    <div class="s-prestige" style="margin-left: 80px"></div>
                                </div>
                                <ul class="s-my-stuffs">
                                    <li>
                                        <a href="{{url_for('user.address')}}" class="J_DropTrigger i-trigger">我的地址</a>
                                    </li>
                                    <li>
                                        <a href="{{url_for('user.user_info',opt_userid=current_user.id)}}" class="J_DropTrigger i-trigger">我的信息</a>
                                    </li>
                                    <li>
                                        <a href="#" class="J_DropTrigger i-trigger"> <em>我的信誉</em> ({{current_user.score}}分)</a>
                                    </li>
                                </ul>
                            </div>
                        </div>
                        <div class="m-logistics g-box-base g-mb-set">
                            <div class="s-bar"><img src="{{url_for('static', filename='img/icon/recentdeal.png')}}" style="width: 28px; height: 28px" />最近交易</div>
                            <div class="s-content">
                                <ul class="lg-list">
                                    <div style="padding: 20px 20px; border-bottom: 1px #f5f5f5 solid; height: 150px">
                                        <div style="float: left; margin-top: 10px">
                                            <img src="{{url_for('static', filename='img/product/bdw_products02.png')}}" style="height: 100px; width: 100px" />
                                        </div>
                                        <div style="float: left; margin-left: 20px; margin-top: 20px">
                                            <p>对方向你发起订单，待同意</p>
                                            <p>2022-04-19 12:20:30 <strong>查看订单详情</strong></p>
                                        </div>
                                        <div style="float: right; margin-right: 20px; margin-top: 50px">
                                            <button style="border: 1px #ccc solid; padding: 5px; background-color: #fff">同意交易</button>
                                        </div>
                                    </div>
                                    <div style="padding: 20px 20px; border-bottom: 1px #f5f5f5 solid; height: 150px">
                                        <div style="float: left; margin-top: 10px">
                                            <img src="{{url_for('static', filename='img/product/bdw_products01.png')}}" style="height: 100px; width: 100px" />
                                        </div>
                                        <div style="float: left; margin-left: 20px; margin-top: 20px">
                                            <p>对方已确认订单完成，待你确认</p>
                                            <p>2022-04-10 12:20:30 <strong>查看订单详情</strong></p>
                                        </div>
                                        <div style="float: right; margin-right: 20px; margin-top: 50px">
                                            <button style="border: 1px #ccc solid; padding: 5px; background-color: #fff">确认完成</button>
                                        </div>
                                    </div>
                                    <p style="text-align: center; margin-top: 30px">展开全部信息</p>
                                </ul>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </section>
</main>
{% endblock %} {% block footer %} {{ super() }} {% endblock %} {% block js %} {{ super() }} {% endblock %}